<component-section>
  <div slot="title">Studiehandleiding</div>
  <component-section>
    <div slot="title">Inleiding</div>
  </component-section>
  <component-section>
    <div slot="title">Toetsen</div>
    <figure>
      <figcaption>
        De bovenste rij staat voor de voltijdse tegenhanger van ADP. De onderste voor ADP zelf. De
        <strong>kolommen</strong> staan voor de onderwijsjaren waarin de course is uitgevoerd. De titels van de
        <strong>cellen</strong> staan voor de code van de desbetreffende course. De <strong>vormen</strong> staan voor
        specifieke deeltentamens, aangeduid met hun code. De <strong>pijlen</strong> tussen cellen staan voor
        veranderingen aan de toetsstructuur. De <strong>dikte van de pijlen</strong> staat voor hoe groot het aandeel
        van de oorspronkelijke toets is in de nieuwe toets. Alle deeltentamens die geconverteerd worden wegen gelijk,
        tenzij de pijldikte verschilt. Conversies met verschillende pijldikte zijn nog niet voorgekomen.
      </figcaption>
      <img
        src="svg/Mutaties_toetsstructuur_course_algoritmes_en_datastructuren.min.svg"
        alt="Mutaties toetsstructuur course" />
    </figure>
    <component-section>
      <div slot="title">
        Kennistoetsen:
        <ul>
          <li><p>Lineair bewaren (<code>D_Ktoets1</code>)</p></li>
          <li><p>Ordenen en sorteren (<code>D_Ktoets2</code>)</p></li>
          <li><p>Zoeken en niet-lineair bewaren (<code>D_Ktoets3</code>)</p></li>
        </ul>
      </div>
      <p>
        Om de drie weken krijg je een kennistoets van een half uur over de leerinhoud van de afgelopen drie weken. Heb
        je recht op extra tijd, dan krijg je je percentage aan extra tijd (meestal 25 %). De kennistoetsen zijn
        schriftelijke tentamens. De tentamens worden afgenomen aan het einde van de donderdagles, met je docent als
        surveillant. Deze keer zijn de kennistoetsen helaas op papier, omdat de examencommissie digitaal tentamineren
        heeft opgeschort, vanwege hun zorg over het frauderisico.
      </p>
      <p>
        Er is een <a href="https://ans.app/digital_test/assignments/276824/routing">proeftoets</a> beschikbaar. Deze
        bevat van de meeste leeruitkomsten voorbeeldvragen.
      </p>
    </component-section>
    <component-section>
      <div slot="title">Opdracht Implementatie van algoritmes en datastructuren (<code>B_Impl</code>)</div>
      <component-section>
        <div slot="title">Inleiding</div>
        <p>
          In deze opdracht leer en toon je vaardigheden waarover je kennis hebt opgedaan in ADP. Kennis over algoritmes
          en datastructuren wordt pas relevant als je in staat bent tot implementatie van de algoritmes. In de praktijk
          zal je vaak bibliotheken gebruiken hiervoor. Maar voor standaardalgoritmes- en datastructuren zou je ook zelf
          in staat moeten zijn tot een eenvoudige een redelijk efficiënte implementatie.
        </p>
      </component-section>
      <component-section>
        <div slot="title">Doel</div>
        <p>
          Ontwikkel implementaties van een reeks algoritmes en datastructuren waarover je in ADP geleerd hebt. Welke
          algoritmes, datastructuren en concepten gevraagd zijn, lees je in het beoordelingsformulier (en in de
          onderwijsbeschrijving op iSAS).
        </p>
        <p>
          De doelstelling van deze opdracht is dat je met algoritmes, datastructuren en gevorderde
          programmeertaalconcepten leert werken. Je mag in een programmeertaal naar keuze ontwikkelen. Besef wel dat
          sommige compilers sowieso efficiëntere software produceren dan andere, en dat de efficiëntie meeweegt in je
          score.
        </p>
        <p>
          Je mag samenwerken, maar niet samen dezelfde uitwerking programmeren. Nogmaals: alles wat je inlevert, moet je
          kunnen uitleggen bij het assessment.
        </p>
      </component-section>
      <component-section>
        <div slot="title">Beoordeling</div>
        <p>
          Zie het
          <a
            href="bron/Beoordelingsmodel%20%C2%B7%20Implementatie%20van%20algoritmes%20en%20datastructuren%20(B_Impl).pdf"
            >beoordelingsformulier</a
          >. \(\text{cijfer} = 9 * (\text{punten} / \text{totaal}) + 1\), minimaal 1 en maximaal 10. Voor de weging van
          dit deeltentamen en overige examineringsinformatie, zie
          <a
            href="https://isas.han.nl/Default.aspx?F=OnderwijsAanbodDetails&Studiejaar=2021&Eigenaar=AIM&OWE=ASD+ADP&Back=A&dt=133016980"
            >iSAS</a
          >.
        </p>
        <p>
          Lever je uitwerking in als een gecomprimeerd archiefbestand op iSAS. Lever ook duidelijke uitleg mee over wat
          er allemaal af is.
        </p>
        <component-section>
          <div slot="title">Minimale testdataset</div>
          <p>
            Om ervoor te zorgen dat jullie implementaties onderling enigszins uitwisselbaar en daarmee vergelijkbaar
            zijn, is er ook een minimale testdataset. Minimaal de volgende dataset in JSON-indeling, met per algoritme
            of datastructuur relevante data, moet je voor de volle score op ‘correctheid’ volledig verwerken:
          </p>
          <ul>
            <li>
              <p>
                <a href="bron/dataset_sorteren.json"><code>dataset_sorteren.json</code></a
                >:
              </p>
              <ul>
                <li>
                  <p>Dynamische rij</p>
                </li>
                <li>
                  <p>Tweevoudig gelinkte list</p>
                </li>
                <li>
                  <p>Stapel</p>
                </li>
                <li>
                  <p>Deque</p>
                </li>
                <li>
                  <p>Prioriteitswachtrij</p>
                </li>
                <li>
                  <p>Binary search</p>
                </li>
                <li>
                  <p>Insertion sort</p>
                </li>
                <li>
                  <p>Selection sort</p>
                </li>
                <li>
                  <p>Quicksort</p>
                </li>
                <li>
                  <p>Parallelle Merge sort</p>
                </li>
                <li>
                  <p>Timsort</p>
                </li>
                <li>
                  <p>Radix sort</p>
                </li>
                <li>
                  <p>AVL-zoekboom (voeg in als items)</p>
                </li>
              </ul>
            </li>
          </ul>
          <ul>
            <li>
              <p>
                <a href="bron/dataset_hashing.json"><code>dataset_hashing.json</code></a
                >:
              </p>
              <ul>
                <li>
                  <p>Hashtabel</p>
                </li>
              </ul>
            </li>
          </ul>
          <ul>
            <li>
              <p>
                <a href="bron/dataset_grafen.json"><code>dataset_grafen.json</code></a
                >:
              </p>
              <ul>
                <li>
                  <p>Graaf</p>
                </li>
                <li>
                  <p>Dijkstra's kortstepadenalgoritme (verwerk ook ongewogen grafen)</p>
                </li>
              </ul>
            </li>
          </ul>
          <p>
            Als je de dataset volledig kan verwerken, betekent dat <em>niet</em> dat je de volle score behaalt. Je
            beoordelaar kan nog extra data gebruiken voor aanvullende tests. Als je de dataset niet volledig kan
            verwerken, betekent dat alleen dat je niet de volle score zal halen. Het blijft dus belangrijk om zelf te
            blijven nadenken en een test suite te ontwikkelen. Je implementaties mogen niet staan of vallen met
            toevallige eigenschappen van de dataset, zoals welke cijfers of letters erin voorkomen.
          </p>
          <p>
            Leid uit de naam van de databestanden en sleutels binnen de JSON af wat de bedoeling is van elk stukje data.
            Soms moet je bepaalde data juist afwijzen in plaats van verwerken. In het algemeen geldt dat een goede
            motivatie van je keuzes, op tijd overleggen met studiegenoten en je beoordelaar om feedback vragen
            verschillen van inzicht tijdens de beoordeling voorkomen.
          </p>
        </component-section>
        <component-section>
          <div slot="title">Correctheid</div>
          <p>
            Je moet al je datastructuren en algoritmes zo generiek mogelijk implementeren. Zo moeten er willekeurige
            objecten van één klasse in iedere lineaire datastructuur passen, en moeten alle ‘vergelijkbare’ objecten
            kunnen worden gesorteerd.
          </p>
          <p>
            Implementeer (minstens) de gangbaarste operaties bij datastructuren. Dit zijn de operaties die uitgelegd
            zijn in de bronnen/reader van de course. Bijvoorbeeld, als het verwijderen van een item ook mogelijk is in
            theorie, dan moet je die operatie dus ook implementeren. Maar als je niet-standaard methoden die ook bestaan
            in andere bibliotheken achterwege laat (bijvoorbeeld
            <code class="lang-java">removeFirstOccurrence</code> of <code class="lang-java">offerLast</code> bij
            <code class="lang-java">java.util.deque</code> van Java), dan kost je dat geen punten. Het naar buiten laten
            lekken van interne details geldt als minder correct.
          </p>
          <p>Implementeer sorteren in zowel aflopende als oplopende volgorde.</p>
        </component-section>
        <component-section>
          <div slot="title">Efficiëntie</div>
          <p>
            Met efficiëntie worden zowel looptijd als geheugenverbruik bedoeld. De efficiëntie telt van uitsluitend elke
            losse implementatie van het algoritme of de operaties op de datastructuur. Dus het inladen van de testdata,
            opstarten van het (test)proces of andere bijzaken niet. Niet de totale looptijd telt, maar de losse per
            algoritme/operatie. Dus parallellisme weegt alleen mee als het algoritme/de operatie zélf parallel is.
          </p>
        </component-section>
        <component-section>
          <div slot="title">Assessment</div>
          <p>
            Je beoordelaar maakt zo snel mogelijk een afspraak met je voor een assessment van je werk. Daarin toetst je
            beoordelaar of de broncode wel echt door jou ontwikkeld is, en of je nog begrijpt in hoeverre je broncode
            correct is. De beoordeling gebeurt als volgt:
          </p>
          <ol>
            <li>
              <p>
                Je beoordelaar analyseert je broncode vooraf aan het assessment. Als je tests voor hem reproduceerbaar
                zijn, benut je beoordelaar ook je tests om te beginnen met het beoordelen.
              </p>
            </li>
            <li>
              <p>
                Als je broncode onvoldoende reproduceerbaar blijkt, moet jij tijdens het assessment alsnog aantonen dat
                je broncode correct is met test-achtige broncode, naast je uitleg.
              </p>
            </li>
            <li>
              <p>
                Ook andere aspecten, zoals de efficiëntie van je implementatie en de kwaliteit van je broncode worden
                vervolgens meegewogen.
              </p>
            </li>
          </ol>
          <p>
            Het is van groot belang dat je resultaten reproduceerbaar zijn en je uitwerking begrijpelijk is. Wil je niet
            verrast worden door tekortkomingen aan de correctheid en efficiëntie, ontwikkel dan zelf een complete suite
            aan unit en performance tests. Pas agressief tools toe die je broncode verbeteren (formatters, linters,
            static analysis tools), zodat je beoordelaar en jijzelf bij het assessment meteen goed snappen hoe je
            broncode werkt. Als je je tests/kwaliteitscontroles ook online uitvoert als CI/CD (GitLab CI, GitHub
            Actions, enzovoort), is het voor je beoordelaar ook sneller duidelijk hoe jouw tests lokaal gedraaid kunnen
            worden.
          </p>
        </component-section>
      </component-section>
    </component-section>
  </component-section>
</component-section>
